unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  FTarget : File of Byte;

implementation

{$R *.DFM}

procedure KonvertBML(Filename : String);
var
  Pic : Array[0..17, 0..7] of Byte;
  F : File of Char;
  X, Y, I : Integer;
  S : String;
  Bits : Byte;
  Linecount : Integer;
  O : Integer;
  Dur : Word;
  B : Byte;
  function ReadLine : String;
  var
    C : Char;
  begin
    result := '';
    repeat
      Read(F, C);
      if (C <> #13) and (C <> #10) then
        result := result + C;
    until eof(F) or (C = #10);
    result := UpperCase(Trim(result));
  end;
begin
  AssignFile(F, Filename);
  Reset(F);

  while not eof(F) do
    begin
      S := ReadLine;
      if copy(S, 1, 4) = '<BLM' then
        begin // extract bitwidth
          I := Pos('BITS=', S);
          if I > 0 then
            begin
              S := Copy(S, I+6, 200);
              I := Pos('"', S);
              S := Copy(S, 1, I-1);
              Bits := StrToInt(S);
            end
          else
            Bits := 4;
        end;
      if copy (S, 1, 6) = '<FRAME' then
        begin
          Y := 0;
          I := Pos('DURATION=', S);
          if I > 0 then
            begin
              S := Copy(S, I+10, 200);
              I := Pos('"', S);
              S := Copy(S, 1, I-1);
              Dur := StrToInt(S);
                Dur := Dur Div 20;
{                if Dur = 0 then
                  Dur := 1;}
              B := lo(Dur);
              Write(FTarget, B);
              B := hi(Dur);
              Write(FTarget, B);
            end
          else
            Bits := 4;
        end;
      if copy(S, 1, 5) = '<ROW>' then
        begin
          s := trim(copy(S, 6, 1000));
          S := Copy(S, 1, 18);
          for X := 0 to 17 do
            begin
              if Bits >= 3 then
                Pic[X, Y] := (Byte(S[X+1])-Byte('0')) shr (Bits-3)
              else
                Pic[X, Y] := (Byte(S[X+1])-Byte('0')) shl (3-Bits);
            end;
          Inc(Y);
          if Y = 8 then
            begin // ein Bild fertig eingelesen
              for X := 0 to 17 do
                for Y := 0 to 7 do
                  Write(FTarget, Pic[X, Y]);
            end;
        end;
    end;
  CloseFile(F);
end;

procedure KonvertBLM(Filename : String);
var
  Pic : Array[0..17, 0..7] of Byte;
  F : File of Char;
  X, Y, I : Integer;
  S : String;
  Bits : Byte;
  Linecount : Integer;
  O : Integer;
  Dur : Word;
  function ReadLine : String;
  var
    C : Char;
  begin
    result := '';
    repeat
      Read(F, C);
      if (C <> #13) and (C <> #10) then
        result := result + C;
    until eof(F) or (C = #10);
    result := UpperCase(Trim(result));
  end;
begin
  AssignFile(F, Filename);
  Reset(F);

  while not eof(F) do
    begin
      S := ReadLine;
      if copy (S, 1, 1) = '@' then
        begin
          S := Trim(Copy(S, 2, 200));
          Dur := StrToInt(S);
            Dur := Dur Div 20;
{            if Dur = 0 then
              Dur := 1;}
          Bits := lo(Dur);
          Write(FTarget, Bits);
          Bits := hi(Dur);
          Write(FTarget, Bits);

          for Y := 0 to 7 do
            begin
              S := ReadLine;
              for X := 0 to 17 do
                if S[X+1] = '0' then
                  Pic[X, Y] := 0
                else
                  Pic[X, Y] := 7;
            end;
          for X := 0 to 17 do
            for Y := 0 to 7 do
              Write(FTarget, Pic[X, Y]);
        end;
    end;
  CloseFile(F);
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  sr : TSearchrec;
  newname : String;

begin
  AssignFile(FTarget, Edit2.text);
  Rewrite(FTarget);
  if Edit1.Text[Length(Edit1.Text)] = '\' then
    Edit1.Text := copy(Edit1.Text, 1, Length(Edit1.Text)-1);
  if FindFirst(Edit1.Text+'\*.*', faArchive, sr) = 0then
    begin
      repeat
        Memo1.Lines.Add( sr.name );
        if uppercase(ExtractFileExt(sr.name)) = '.BLM' then
          begin
            KonvertBlm(Edit1.Text+'\'+sr.name);
          end
        else if uppercase(ExtractFileExt(sr.name)) = '.BML' then
          begin
            KonvertBml(Edit1.Text+'\'+sr.name);
          end;
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;
  CloseFile(FTarget);
end;

end.

